'''\
socket handler for clorn
'''
import socket
# s
import os
import sys
import re
import shutil
import builtins
# h
class HttpStatusError(builtins.Exception):
	pass
def sock():
	try:
		server=socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		server.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
		return server
	except:
		print('failed to create streamer')
		return None
def hr(code):
	hcl={
        "100":"Continue",
        "101":"Switching",
        "102":"Processing",
        "200":"OK",
        "201":"Created",
        "202":"Accepted",
        "203":"Non-authoritative",
        "204":"No",
        "205":"Reset",
        "206":"Partial",
        "207":"Multi-Status",
        "208":"Already",
        "226":"IM",
        "300":"Multiple",
        "301":"Moved",
        "302":"Found",
        "303":"See",
        "304":"Not",
        "305":"Use",
        "307":"Temporary",
        "308":"Permanent",
        "400":"Bad",
        "401":"Unauthorized",
        "402":"Payment",
        "403":"Forbidden",
        "404":"Not",
        "405":"Method",
        "406":"Not",
        "407":"Proxy",
        "408":"Request",
        "409":"Conflict",
        "410":"Gone",
        "411":"Length",
        "412":"Precondition",
        "413":"Payload",
        "414":"Request-URI",
        "415":"Unsupported",
        "416":"Requested",
        "417":"Expectation",
        "418":"I'm",
        "421":"Misdirected",
        "422":"Unprocessable",
        "423":"Locked",
        "424":"Failed",
        "426":"Upgrade",
        "428":"Precondition",
        "429":"Too",
        "431":"Request",
        "444":"Connection",
        "451":"Unavailable",
        "499":"Client",
        "500":"Internal",
        "501":"Not",
        "502":"Bad",
        "503":"Service",
        "504":"Gateway",
        "505":"HTTP",
        "506":"Variant",
        "507":"Insufficient",
        "508":"Loop",
        "510":"Not",
        "511":"Network",
        "599":"Network"
}
	code0=int(code)
	code=str(code0)
	if code in hcl:
		return f'{code} {hcl[code]}'
	else:
		raise HttpStatusError(f'Unknown HTTP Status code {code}')
class URLP:
	url=''
	pattern=''
def urlifystr(url):
	url=str(url)
	try:
		if url[-1]=='/':
			return url[:-1]
		else:
			return url
	except:
		return url
def urlify(url):
	url=str(url)
	URLP.url=url
	if url=='/':
		return url
	else:
		return urlifystr(url)
class URL:
	def parse(pattern):
		URLP.pattern=pattern
	def get(key):
		p0="^"+str(re.escape(URLP.pattern))+"$"
		p=re.sub('<[^>]+>', "(?P\g<0>.*)", p0)
		exp=re.compile(p, re.DOTALL)
		routed=exp.match(URLP.url)
		try:
			return routed.group(key)
		except:
			pass