'''
'''

import time
from . import SOHT as soht 
import builtins
import traceback
import re
import os
class HTTP:
	protocol='http'
	code=200
protocol=HTTP.protocol
class BindError(builtins.Exception):pass
class _request_:
	request=None
	method=None
	path=None
def app(function):
	def response(host='127.0.0.1', port=9000, debug=True):
		server=soht.sock()
		try:
			server.bind((host, port))
		except:
			raise BindError('Failed to bind host and port') from None
		server.listen(1)
		print('Server started')
		print(f'* environment: {os.environ.get("CLORN_ENV", "production")}')
		print('  to set environment variable to development/production as "export CLORN_ENV=development/production"')
		print(f'* Debug: {debug}')
		print('* listening at %s://%s:%s/\r\n' %(protocol, host, port))
		try:
			while True:
				client, clientaddr=server.accept()
				request=client.recv(1024).decode()
				try:
					method=request.split('\n')[0].split()[0]
				except:
					method='GET'
				try:
					path=soht.urlify(request.split('\n')[0].split()[1])
				except:
					path=''
				try:
					flom=request.split("\n")[0]
				except:
					flom='GET / HTTP/1.0'
				time_str=time.strftime("%m/%d/%Y %H:%M:%S")
				
				def c500(arg):
					print(f'\r\n{traceback.format_exc()}\r\n')
					return f'''
<h1 style='text-align: center;'>500</h1>
<p style='text-align: center;'>Server Error</p>'''

				try:
					function.__name__
					length_=function.__code__.co_argcount
					if int(length_)==0:
						function_text=function()
					elif int(length_)==1:
						function_text=function(path)
					else:
						pass
				except Exception as e:
					function_text='{%500%}'+str(c500(e))
			
				if '{%' in str(function_text):
					code_=re.findall('{%(.*?)%}', function_text)
					try:
						code_=code_[0]
						code__=int(code_)
						HTTP.code=code__
					except:
						code_=code_
				else:
					HTTP.code=200
				print(str(f'{host} - - [{time_str}] "{flom}"  {HTTP.code} - '.encode())[2:][:-1])
				_request_.method=method
				_request_.request=request
				_request_.path=path
				http_request=HTTP.code
				function_text=str(function_text).replace('{%'+str(HTTP.code)+'%}', '')
				length_of_body=len(function_text)
				response=f'HTTP/1.0 {soht.hr(http_request)}\r\nContent-Type: text/html; charset=utf-8\r\nContent-Length: {length_of_body}\r\nServer: clorn/0.0.1\r\n\r\n{function_text}'
				try:
					client.sendall(response.encode('utf-8'))
				except:
					print('failed to send response')
				#HTTP.code=200
				client.close()
		except KeyboardInterrupt:
			server.close()
	return response